function  [finalFeat,numOfTotAcc,numOfTotGyro]=GenerateFeatures(nameFile,LabelCorr,NumbOfSample,vector,NumberOfsegmentToAverage)

    fid=fopen(nameFile,'r');
    
    finalFeat=[];
    finalFeatSub=[];
    newSection();
    numOfTotAcc=0;
    numOfTotGyro=0;
    cur_row_file=0;
    minNumberElements=max(10,NumbOfSample);

    while 1
        %cur_row_file=cur_row_file+1
        tline = fgetl(fid);
        if (size(tline,2)==0)
            tline='Z';
        end
        if ~ischar(tline) || tline(1)=='N'
            finalFeat=[finalFeat;currSection];
            finalFeatSub=[finalFeatSub;currSectionSub];
            newSection();
        end

        if ~ischar(tline), break, end

        if tline(1)=='R'
            newSection();
        end
        if tline(1)=='G'
            currDataG=sscanf(tline(3:end),'%f,%f,%f')';
            if size(currDataG,2)==3
                sampleVectG=[sampleVectG;currDataG];
            end
        end
        if tline(1)=='A'
            currDataA=sscanf(tline(3:end),'%f,%f,%f')';
            if size(currDataA,2)==3
                sampleVectA=[sampleVectA;currDataA];
            end
        end
        if tline(1)=='L'
            if size(sampleVectG,1)>minNumberElements && size(sampleVectA,1)>minNumberElements && size(sampleVectA,1)<200*NumberOfsegmentToAverage*5 && size(sampleVectG,1)<200*NumberOfsegmentToAverage*5
                currSegmentAveareged=currSegmentAveareged+1;
                if currSegmentAveareged==NumberOfsegmentToAverage
                    currentLabel=tline(3:end);
                    numOfTotAcc=numOfTotAcc+size(sampleVectA,1);                   
                    numOfTotGyro=numOfTotGyro+size(sampleVectG,1);
                    diffA=diff(sampleVectA);
                    diffG=diff(sampleVectG);
                    if (size(find(strcmpi(LabelCorr,currentLabel)))>0)
                        currSection(currRowInSection,:)=[
                            mean(diffG),var(diffG),std(diffG),rms(diffG),max(sampleVectG),min(sampleVectG),max(sampleVectG)-min(sampleVectG),std(sampleVectG),mean(sampleVectG),var(sampleVectG),skewness(sampleVectG),kurtosis_apache(sampleVectG(:,1)),kurtosis_apache(sampleVectG(:,2)),kurtosis_apache(sampleVectG(:,3)),zerocross(sampleVectG),meancross(sampleVectG),iqr(sampleVectG),median(sampleVectG),rms(sampleVectG),... %87
                            mean(diffA),var(diffA),std(diffA),rms(diffA),max(sampleVectA),min(sampleVectA),max(sampleVectA)-min(sampleVectA),std(sampleVectA),mean(sampleVectA),var(sampleVectA),skewness(sampleVectA),kurtosis_apache(sampleVectA(:,1)),kurtosis_apache(sampleVectA(:,2)),kurtosis_apache(sampleVectA(:,3)),zerocross(sampleVectA),meancross(sampleVectA),iqr(sampleVectA),median(sampleVectA),rms(sampleVectA),... %138
                            find(strcmpi(LabelCorr,currentLabel))];

                        currSectionSub(currRowInSection,:)=currSection(currRowInSection,[vector,end]);
                        currRowInSection=currRowInSection+1;
                        emptyVector();
                    else
                        disp(['Error: ', currentLabel,' is not in the database']);
                    end
                end
            else
                 if size(sampleVectA,1)>200*NumberOfsegmentToAverage*5 || size(sampleVectG,1)>200*NumberOfsegmentToAverage*5
                        size(sampleVectA,1)
                        size(sampleVectG,1)                        
                  end
                emptyVector();
            end
        end

    end
    fclose(fid);
    if nargin>3
        finalFeat=finalFeatSub;
    end
        function newSection()
            currSection=[];
            currSectionSub=[];
            currRowInSection=1;
            emptyVector();
        end

        function emptyVector()
            sampleVectG=[];
            sampleVectA=[];
            currSegmentAveareged=0;
        end
end


function z=zerocross(v)
for i=1:size(v,2)
    z(i)=size(find(diff(v(:,i)'>0)~=0),2);
end
end


function z=meancross(v)
for i=1:size(v,2)
    z(i)=size(find(diff(v(:,i)'>mean(v(:,i)'))~=0),2);
end
end


function y = kurtosis_apache(x)

n=length(x);
mean_x = mean(x);
std_x = std(x);

y = ( (n*(n+1) / ((n -1)*(n - 2)*(n-3))) * sum((x - mean_x).^4) / std_x.^4 ) - ((3*(n-1).^2) / ((n-2)*(n-3)));
end
