function  [finalFeat,sizeOfSpect]=GenerateFeaturesComb(nameFile,LabelCorr,NumbOfSample,NumberOfsegmentToAverage,spectrogramSizeTime,spectrogramSizeFrequenz)

fid=fopen(nameFile,'r');

finalFeat=[];
cur_row_inFile=0;
newSection()
minNumberElements=max(10,NumbOfSample);

while 1
    %cur_row_inFile=cur_row_inFile+1
    tline = fgetl(fid);
    if (size(tline,2)==0)
        tline='Z';
    end
    if ~ischar(tline) || tline(1)=='N'
        %new Section section
        size(finalFeat)
        size(currSectionFeat)
        finalFeat=[finalFeat;currSectionFeat];
        newSection()
    end
    
    if ~ischar(tline), break, end
    
    if tline(1)=='R'
        %remove last section
        newSection()
    end
    if tline(1)=='G'
        %data from gyro
        currDataG=sscanf(tline(3:end),'%f,%f,%f')';
        if size(currDataG,2)==3
            sampleVectG=[sampleVectG;currDataG];

        end
    end
    if tline(1)=='A'
        %data from acc
        currDataA=sscanf(tline(3:end),'%f,%f,%f')';
        if size(currDataA,2)==3
            sampleVectA=[sampleVectA;currDataA];

        end
    end
    if tline(1)=='L'
        %label each 5 second
        if size(sampleVectG,1)>minNumberElements && size(sampleVectA,1)>minNumberElements && size(sampleVectA,1)<200*NumberOfsegmentToAverage*5 && size(sampleVectG,1)<200*NumberOfsegmentToAverage*5
            currSegmentAveareged=currSegmentAveareged+1;
            if currSegmentAveareged==NumberOfsegmentToAverage
                currentLabel=tline(3:end);
                
                sampleVectG=sampleVectG(1:floor(size(sampleVectG(:,1),1)/spectrogramSizeTime)*spectrogramSizeTime,:);
                sampleVectA=sampleVectA(1:floor(size(sampleVectA(:,1),1)/spectrogramSizeTime)*spectrogramSizeTime,:);
                                 
                s=[spectrogram(sampleVectG(:,1),floor(size(sampleVectG(:,1),1)/spectrogramSizeTime),0,spectrogramSizeFrequenz),spectrogram(sampleVectG(:,2),floor(size(sampleVectG(:,2),1)/spectrogramSizeTime),0,spectrogramSizeFrequenz),spectrogram(sampleVectG(:,3),floor(size(sampleVectG(:,3),1)/spectrogramSizeTime),0,spectrogramSizeFrequenz),
                                       spectrogram(sampleVectA(:,1),floor(size(sampleVectA(:,1),1)/spectrogramSizeTime),0,spectrogramSizeFrequenz),spectrogram(sampleVectA(:,2),floor(size(sampleVectA(:,2),1)/spectrogramSizeTime),0,spectrogramSizeFrequenz),spectrogram(sampleVectA(:,3),floor(size(sampleVectA(:,3),1)/spectrogramSizeTime),0,spectrogramSizeFrequenz)];
                
                sizeOfSpect=size(s);      
                diffA=diff(sampleVectA);
                diffG=diff(sampleVectG);
                tmp= [mean(diffG),var(diffG),std(diffG),rms(diffG),max(sampleVectG),min(sampleVectG),max(sampleVectG)-min(sampleVectG),std(sampleVectG),mean(sampleVectG),var(sampleVectG),skewness(sampleVectG),kurtosis_apache(sampleVectG(:,1)),kurtosis_apache(sampleVectG(:,2)),kurtosis_apache(sampleVectG(:,3)),zerocross(sampleVectG),meancross(sampleVectG),iqr(sampleVectG),median(sampleVectG),rms(sampleVectG),... %87
                            mean(diffA),var(diffA),std(diffA),rms(diffA),max(sampleVectA),min(sampleVectA),max(sampleVectA)-min(sampleVectA),std(sampleVectA),mean(sampleVectA),var(sampleVectA),skewness(sampleVectA),kurtosis_apache(sampleVectA(:,1)),kurtosis_apache(sampleVectA(:,2)),kurtosis_apache(sampleVectA(:,3)),zerocross(sampleVectA),meancross(sampleVectA),iqr(sampleVectA),median(sampleVectA),rms(sampleVectA)];

                currSectionFeat(currRowInSection,:)=[tmp(1:102),abs(s(:))',find(strcmpi(LabelCorr,currentLabel))];
              
                                    
                currRowInSection=currRowInSection+1;
                emptyVector();
            end
        end
    end

    
end
fclose(fid);


    function emptyVector()
        currSegmentAveareged=0;
        sampleVectG=[];
        sampleVectA=[];
    end

    function newSection()
        currSectionFeat=[];
        currRowInSection=1;
        emptyVector();
    end
end



function z=zerocross(v)
for i=1:size(v,2)
    z(i)=size(find(diff(v(:,i)'>0)~=0),2);
end
end


function z=meancross(v)
for i=1:size(v,2)
    z(i)=size(find(diff(v(:,i)'>mean(v(:,i)'))~=0),2);
end
end


function y = kurtosis_apache(x)

n=length(x);
mean_x = mean(x);
std_x = std(x);

y = ( (n*(n+1) / ((n -1)*(n - 2)*(n-3))) * sum((x - mean_x).^4) / std_x.^4 ) - ((3*(n-1).^2) / ((n-2)*(n-3)));
end

