require 'nn'
require 'torch'
require 'xlua'
require 'image'
require 'optim'



dofile('setParameters.lua')

-- nb of threads and fixed seed (for repeatable experiments)
if opt.type == 'float' then
   print('==> switching to floats')
   torch.setdefaulttensortype('torch.FloatTensor')
elseif opt.type == 'cuda' then
   print('==> switching to CUDA')
   require 'cunn'
   torch.setdefaulttensortype('torch.FloatTensor')
end
torch.setnumthreads(opt.threads)
torch.manualSeed(opt.seed)

os.execute('mkdir ' .. "../rawData")
dofile('extract_DB.lua')
dofile('normalize.lua')


print(opt.isfeatures)
if opt.loadPrecomputedModel then
   local filename = paths.concat(opt.save, opt.label..'model.net')
   model=torch.load(filename,'ascii')     
   criterion = nn.ClassNLLCriterion()
   print(model)
else
   if opt.typeModel=='feat' then
      model=dofile('CreateModel_feat.lua')
    elseif opt.typeModel=='fft1' then
      model=dofile('CreateModel_fft1.lua')
    elseif opt.typeModel=='fft2' then
      model=dofile('CreateModel_fft2.lua')
    elseif opt.typeModel=='fft3' then
      model=dofile('CreateModel_fft3.lua')
    elseif opt.typeModel=='spect1' then
      model=dofile('CreateModel_spect1.lua')
    elseif opt.typeModel=='spect2' then
      model=dofile('CreateModel_spect2.lua')
    elseif opt.typeModel=='spect3' then
      model=dofile('CreateModel_spect3.lua')
    elseif opt.typeModel=='spect4' then
      model=dofile('CreateModel_spect4.lua')
    elseif opt.typeModel=='spect5' then
      model=dofile('CreateModel_spect5.lua')
    elseif opt.typeModel=='spect6' then
      model=dofile('CreateModel_spect6.lua')
    elseif opt.typeModel=='spect7' then
      model=dofile('CreateModel_spect7.lua')
    elseif opt.typeModel=='spect8' then
      model=dofile('CreateModel_spect8.lua')
    elseif opt.typeModel=='comb' then
      model=dofile('CreateModel_comb.lua')
    end
   dofile('CreateLossFunction.lua')
end

dofile('training.lua')
dofile('test.lua')
currScore=0
WaitIteration=0
--while WaitIteration<3 do
for i=1,400 do
	if currScore==100 then
		WaitIteration=WaitIteration+1;
	else
	    WaitIteration=0;
	end
	currScore=trainProcess()
	t1 = os.time()
	testProcedure()
	t2 = os.time()
	print('Start time: ' .. t1)
	print('End time: ' .. t2)
	print('Computation time: ' .. os.difftime(t2,t1) .. 's')	
end
