

----------------------------------------------------------------------
print '==> defining test procedure'

-- test function
function testProcedure()
   -- local vars
   local time = sys.clock()

   -- averaged param use?
   if average then
      cachedparams = parameters:clone()
      parameters:copy(average)
   end
   tstsize=test.images:size(1)
   -- set model to evaluate mode (for modules that differ in training and testing, like Dropout)
   model:evaluate()

   -- test over test data
   print('==> testing on test set:')
   for t = 1,tstsize do
      -- disp progress
      xlua.progress(t, tstsize)

      -- get new sample
      local input = test.images[t]
      if opt.type == 'double' then input = input:double() 
      elseif opt.type == 'float' then input = input:float() end
      local target = test.labels[t]

      -- test sample
      local pred = model:forward(input)
     --[[y,class=torch.min(pred,1)
      print(target)
      print(tostring(class[1]))--]]
      confusion:add(pred:resize(opt.noutputs), target)
      --tmp,iiiii=torch.max(pred,2)
      --confusion:add(iiiii:storage()[1], target)
   end

   -- timing
   time = sys.clock() - time
   time = time / tstsize
   print("\n==> time to test 1 sample = " .. (time*1000) .. 'ms')

   -- print confusion matrix
   print(confusion)
   
   
   local filename = paths.concat(opt.save, opt.label..'confusionMatrix.net')    
   file = torch.DiskFile(filename, 'w')
   file:writeObject(confusion)
   file:close()

   -- update log/plot
   testLogger:add{['% mean class accuracy (test set)'] = confusion.totalValid * 100}
   if opt.plot then
      testLogger:style{['% mean class accuracy (test set)'] = '-'}
      testLogger:plot()
   end

   -- averaged param use?
   if average then
      -- restore parameters
      parameters:copy(cachedparams)
   end   
   -- next iteration:
   confusion:zero()

end
